---

wireguard_clients_config: "{{ lookup('community.hashi_vault.hashi_vault', 'clients/data/routers/fw-extranet-th2-hxg/wireguard') }}"
wireguard_clients_peers_raw: |
  {% for peer in wireguard_clients_config.peers %}
  - allowed-ips: ["{{ peer.ipv4_address }}/32"]
    keys:
      public: "{{ peer.public_key }}"
      shared: "{{ peer.preshared_key }}"
  {% endfor %}
wireguard_clients_peers: "{{ wireguard_clients_peers_raw | from_yaml }}"

wireguard_admin_config: "{{ lookup('community.hashi_vault.hashi_vault', 'infra/data/extranet/wireguard/admin/router') }}"
wireguard_admin_peers_raw: |
  {% for peer_name in lookup('community.hashi_vault.vault_list', 'infra/metadata/extranet/wireguard/admin/peers')['data']['keys'] %}
  {% with peer=lookup('community.hashi_vault.hashi_vault', 'infra/data/extranet/wireguard/admin/peers/' + peer_name) %}
  - allowed-ips: ["{{ peer.ipv4_address }}/32"]
    keys:
      public: "{{ peer.public_key }}"
      shared: "{{ peer.preshared_key }}"
  {% endwith %}
  {% endfor %}

wireguard_admin_peers: "{{ wireguard_admin_peers_raw | from_yaml }}"

netplan_configuration:
  network:
    version: 2
    vrfs:
      vrf100:
        table: 100
        interfaces:
          - ens4
          - intersite0
          - admin0
          - clients0
    tunnels:
      intersite0:
        mode: wireguard
        port: 45319
        addresses: ["100.80.250.1/24"]
        routes:
          - to: 100.80.80.0/24
            via: 100.80.250.2
          - to: 100.80.81.0/24
            via: 100.80.250.2
          - to: 100.80.82.0/24
            via: 100.80.250.2
          - to: 10.201.13.0/24
            via: 100.80.250.2
          - to: 10.202.0.0/16
            via: 100.80.250.2
        key:
          private: "{{ lookup('community.hashi_vault.hashi_vault', 'infra/data/extranet/wireguard/intersite/peers/fw-extranet:private_key') }}"
        peers:
          - keys:
              public: "{{ lookup('community.hashi_vault.hashi_vault', 'infra/data/extranet/wireguard/intersite/peers/fw-epita:public_key') }}"
            allowed-ips:
              - 100.80.250.2/32 # interco
              - 100.80.80.0/24 # prod
              - 100.80.81.0/24 # admin
              - 100.80.82.0/24 # mgmt
              - 10.201.13.0/24 # DMZ
              - 10.202.0.0/16 # EPITA PIE
      admin0:
        mode: wireguard
        port: "{{ wireguard_admin_config.listen_port }}"
        addresses: ["{{ wireguard_admin_config.ipv4_address }}"]
        key:
          private: "{{ wireguard_admin_config.private_key }}"
        peers: "{{ wireguard_admin_peers }}"
      clients0:
        mode: wireguard
        port: "{{ wireguard_clients_config.listen_port }}"
        addresses: ["{{ wireguard_clients_config.ipv4_address }}"]
        key:
          private: "{{ wireguard_clients_config.private_key }}"
        peers: "{{ wireguard_clients_peers }}"
    ethernets:
      ens3:
        link-local: []
        addresses:
          - 192.168.1.21/24
        gateway4: 192.168.1.254
        nameservers:
          addresses: "{{ network_nameservers }}"
      ens4:
        link-local: []
        addresses:
          - 100.80.1.254/24
